<template>
  <div class="card">
    <h3>{{ selectedRestaurant.name }}</h3>
    <label>
    {{
      selectedRestaurant.reviews.length
      ? 'Average rating: ' +  getAverageRating() + '/5'
      : ''
    }}
    </label>
    <star-rating :rating="getAverageRating()"></star-rating>
    <label>{{ selectedRestaurant.reviews.length }} reviews</label>
    <div v-if="selectedRestaurant.reviews.length">
      <label><strong>Highest Rated Review</strong></label>
      <review :review="highestRatedReview"></review>
      <label><strong>Lowest Rated Review</strong></label>
      <review :review="lowestRatedReview"></review>
      <label><strong>Latest Reviews</strong></label>
      <review v-for="(review, index) in allReviews"
      :key="index"
      :review="review">
      </review>
    </div>
    <dynamic-form
    v-if="edit"
    v-on:success="editRestaurantSuccessful"
    headerText="Edit Restaurant"
    buttonText="Submit Changes"
    :endpointUrl="'/api/restaurants/' + selectedRestaurant._id"
    endpointType="put"
    :fields="[
      {
        name: 'name',
        label: 'Name',
        type: 'text',
        required: true,
        value: selectedRestaurant.name,
      },
    ]">
    </dynamic-form>
    <span class="edit-delete-buttons" v-if="user.role == 'admin'">
      <input type="button"
      :disabled="edit"
      class="edit-button"
      v-on:click="editRestaurant()"
      value="Edit restaurant">
      <input type="button"
      class="delete-button"
      v-on:click="deleteRestaurant()"
      value="Delete restaurant">
    </span>
    <div class="loading-spinner-overlay" v-if="loading"></div>
  </div>
</template>

<script>
import review from './Review.vue';
import dynamicForm from './DynamicForm.vue';
import store from '../store/index';
import { mapState } from 'vuex';
import getAverageRestaurantRating from '../functions/getAverageRestaurantRating';
import starRating from './StarRating.vue';
import axios from 'axios';
import { proxy } from '../config/proxy';

export default {
  computed: {
    ...mapState([
      'selectedRestaurant',
      'user',
    ]),
    highestRatedReview() {
      return this.selectedRestaurant.reviews.reduce((prev, current) => {
        return (prev.rating > current.rating) ? prev : current;
      });
    },
    lowestRatedReview() {
      return this.selectedRestaurant.reviews.reduce((prev, current) => {
        return (prev.rating < current.rating) ? prev : current;
      });
    },
    allReviews() {
      return this.selectedRestaurant.reviews;
    },
  },
  components: {
    review,
    dynamicForm,
    starRating,
  },
  data() {
    return {
      edit: false,
      loading: false,
    };
  },
  methods: {
    getAverageRating() {
      return getAverageRestaurantRating(this.selectedRestaurant);
    },
    deleteRestaurant() {
      // toggle loading spinner on
      this.loading = true;
      // http request
      axios.delete(proxy + '/api/restaurants/' + this.selectedRestaurant._id).then((response) => {
        // remove restaurant in the frontend
        store.commit('deleteRestaurantSuccessful', {
          restaurant: response.data,
        })
        // toggle loading spinner off
        this.loading = false;
      }).catch((error) => {
        // log error message
        console.log({ error: error.message });
        // toggle loading spinner off
        this.loading = false;
      });
    },
    editRestaurant() {
      this.edit = true;
    },
    editRestaurantSuccessful(response) {
      this.edit = false;
      store.commit('editRestaurantSuccessful', {
        restaurant: response.data,
      });
    },
  },
}
</script>

<style lang="scss">

</style>
